# Composition guidelines
The following are guidelines for rendering image assets.

## General
### Color Management
- Filmic - Medium High Contrast

### World
- Global Illumination - 1.0

### Sun
- Strength - 5.0

### Volume
- Fournier-Forand
- IOR 1.0
- Density 0.01

## Icon
400 x 400 RGBA PNG

### Item
- Camera position should be x=0.0, Y=1.0, Z=0.0.
- Camera angle should be X=90, Y=0, Z=180.
- Camera perspective @ focal length 30mm.
- Camera DOF @ item.

### Block
- Camera position should be X=0.5, Y=1.0, Z=0.5.
- Camera angle should be X=90, Y=0, Z=150.
- Camera should have a damped track to block.
- Camera should have a rotation limit on the y axis.
- Camera no DOF.
- Camera orthographic @ scale 2.0.

## Banner
1200 x 400 RGB PNG

- Camera perspective @ focal length 50mm (1x).
- Camera DOF @ focus distance 5m (1x).
- Gap between icon and text should be 1 grid.
- Text is Minecraft font, size 72.
- Text has 4px stroke.
- Icon has default drop shadow.

## Logo
400 x 400 RGB PNG

- Camera perspective @ focal length 150mm (3x).
- Camera DOF @ focus distance 15m (3x).

## Card
200 x 300 RGB PNG

- Camera perspective @ focal length 150mm (3x).
- Camera DOF @ focus distance 15m (3x).
- Icon should be scaled down to half.
- Gap between icon and text should be 1 grid.
- Text is Minecraft font, size 26.
- Text has 2px stroke.
- Icon has default drop shadow.
